# nn_term(3compat) Manual Page

## NAME

nn_term - terminate library (compatible API)

## SYNOPSIS

    #include <nanomsg/nn.h>

    void nn_term(void);

## DESCRIPTION

The `nn_term()` function closes any open sockets, and frees all resources allocated by the library. Any operations that are currently in progress will be terminated, and will fail with error `EBADF` or `ETERM`.

| This function is provided for API compatibility with legacy libnanomsg. Consider using the relevant modern API instead.

This function is not thread-safe, and is not suitable for use in library calls. The intended purpose of this is to clean up at application termination; for example by registering this function with `atexit()`. This can help prevent false leak reports caused when memory checkers notice global resources allocated by the library. Libraries should never use this function, but should explicitly close their own sockets directly.

## RETURN VALUES

None.

## ERRORS

None.

## SEE ALSO

nn_errno(3compat), nn_socket(3compat), nng_compat(3compat), nng(7)